<template>
  <div class="input-wrapper" :style="{ width: inputWidth }">
    <label class="input-container" :for="inputId">
      <input
        ref="input"
        :id="inputId"
        class="input-row"
        :class="{ isfocused: isFocused }"
        :value="inputValue"
        :v-model="inputValue"
        v-bind="$attrs"
        :placeholder="props.placeHolder"
        @focus="onFocus"
        @blur="onBlur"
        @input="(event) => emit('update:inputValue', event.target.value)"
      />
      <Transition name="slide-fade">
        <p class="input-placeholder" v-if="isFocused || props.inputValue">
          {{ placeHolder }}
        </p>
      </Transition>
      <span class="input-clear" v-if="props.inputValue" @click="clearInputValue">
        <nuxt-icon name="IconClose" filled/>
      </span>
    </label>
    <BaseFieldErrors :errors="$attrs.errors" />
  </div>
</template>

<script setup>
defineOptions({
  inheritAttrs: false,
});

const props = defineProps({
  placeHolder: String,
  inputWidth: String,
  inputValue: String,
  inputId: String,
});
const emit = defineEmits(["update:inputValue"]);
const input = ref(null);
const isFocused = ref(false);
const onFocus = () => {
  isFocused.value = true;
};
const onBlur = () => {
  isFocused.value = false;
};
const clearInputValue = () => {
  input.value.value = "";
  emit("update:inputValue", "");
};
</script>

<style lang="sass" scoped>
@import '/assets/styles/_variables.sass'
.input
    &-wrapper
        display: flex
        flex-direction: column
    &-container
        display: block
        min-width: 30%
        position: relative
    &-row
        width: 100%
        height: 2rem
        padding: .3rem .5rem
        border-radius: 4px
        border: 1px solid $darkgrey
        outline: none
        font-size: $fz
    &-placeholder
        position: absolute
        font-size: $fz * 0.7
        margin: 0
        top: -31%
        left: 4%
        background: $white
        padding: 0 4px
    &-clear
        cursor: pointer
        background: transparent
        border: none
        width: 1rem
        position: absolute
        opacity: .5
        top: 12%
        left: 92%
        .icon
            width: $fz* 0.8
            height: $fz* 0.8
        &:hover
            opacity: 1
            transition: .2s ease-in

.isfocused
    transition: all 0.3s ease-in
    border: 1px solid #033fc0fc
.slide-fade-enter-active
  transition: all 0.3s ease-out

.slide-fade-leave-active
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1)

.slide-fade-enter-from, .slide-fade-leave-to
  transform: translateY(20px)
  opacity: 0
</style>
